package com.example.aitest.service.impl;

import com.example.aitest.dao.redis.RedisUtil;
import com.example.aitest.jwt.JWTUtil;
import com.example.aitest.mapper.UserMapper;
import com.example.aitest.pojo.User;
import com.example.aitest.service.UserService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
@Service
public class UserServiceImpl implements UserService {

    @Resource
    public UserMapper userMapper;
    @Resource(name = "tokenRedis")
    public RedisUtil tokenRedis;
    @Override
    public String login(User user) throws NoSuchAlgorithmException {
        MessageDigest md5 = MessageDigest.getInstance("MD5");
        md5.update(user.getPassword().getBytes());
        byte[] digest = md5.digest();
        user.setPassword(parseByte2HexStr(digest));
        User loginUser = userMapper.login(user);
        System.out.println(loginUser);
        if (loginUser != null) {
            String token = JWTUtil.sign(user.getPhone());
            tokenRedis.addRedis(user.getPhone(), token);
            return token;
        }
        return "登录失败";
    }

    @Override
    public String register(User user) throws NoSuchAlgorithmException {
        if (userMapper.getUser(user) != null) {
            return "用户已存在";
        }
        MessageDigest md5 = MessageDigest.getInstance("MD5");
        md5.update(user.getPassword().getBytes());
        byte[] digest = md5.digest();
        user.setPassword(parseByte2HexStr(digest));
        userMapper.register(user);
        return "注册成功";
    }

    private String parseByte2HexStr(byte[] buf) {
        StringBuilder sb = new StringBuilder();
        for (byte b : buf) {
            String hex = Integer.toHexString(b & 0xFF);
            if (hex.length() == 1) {
                hex = '0' + hex;
            }
            sb.append(hex.toUpperCase());
        }
        return sb.toString();
    }
}
