package com.example.aitest;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.IOException;

@SpringBootTest
class AiTestApplicationTests {
    private static final String API_SECRET_KEY = "sk-zk23dcb27bb18e67d9ea0d749ed62f8088a667936c4c0682";
    private static final String BASE_URL = "https://api.zhizengzeng.com/v1/chat/completions";

    @Test
    void contextLoads() {
        CloseableHttpClient httpClient = HttpClients.createDefault();
        System.out.println("进入processImage");
        // 构建请求体
        JSONObject content = new JSONObject();
        content.put("type", "text");
        content.put("text", "请你对该图片的人物行为进行分析");

        JSONObject imageContent = new JSONObject();
        imageContent.put("type", "image_url");
        JSONObject imageUrl = new JSONObject();
        imageUrl.put("url", "http://124.71.135.249:8081/images/avatar/1718618415826.jpg");
        imageContent.put("image_url", imageUrl);

        JSONObject message = new JSONObject();
        message.put("role", "user");
        message.put("content", new JSONObject[]{content, imageContent});

        JSONObject requestBodyJson = new JSONObject();
        requestBodyJson.put("model", "gpt-4o");
        requestBodyJson.put("messages", new JSONObject[]{message});
        requestBodyJson.put("max_tokens", 300);

        StringEntity requestEntity = new StringEntity(requestBodyJson.toJSONString(), ContentType.APPLICATION_JSON);

        HttpPost httpPost = new HttpPost(BASE_URL);
        httpPost.setHeader("Authorization", "Bearer " + API_SECRET_KEY);
        httpPost.setHeader("Content-Type", "application/json");
        httpPost.setEntity(requestEntity);
        try (CloseableHttpResponse response = httpClient.execute(httpPost)) {
//            if (response.getCode() != 200) {
//                throw new HttpResponseException(response.getCode(), "Unexpected response status");
//            }
            // Parse the JSON response
            String responseBody = new String(response.getEntity().getContent().readAllBytes());
            JSONObject jsonResponse = JSON.parseObject(responseBody);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}


